SystemOrganization addCategory: #'Athens-Cairo'!
SystemOrganization addCategory: #'Athens-Cairo-Paints'!
SystemOrganization addCategory: #'Athens-Cairo-Paths'!
SystemOrganization addCategory: #'Athens-Cairo-Text'!
SystemOrganization addCategory: #'Athens-Cairo-Transforms'!

Trait named: #TCairoLibrary
	uses: {}
	category: 'Athens-Cairo'!

!TCairoLibrary classSide methodsFor: 'library path' stamp: 'IgorStasenko 12/20/2011 16:53'!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!TCairoLibrary methodsFor: 'library path' stamp: 'IgorStasenko 12/20/2011 16:52'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

NBExternalStructure variableByteSubclass: #SQSurfaceDispatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!SQSurfaceDispatch commentStamp: 'IgorStasenko 12/30/2011 12:35' prior: 0!
A structure from SurfacePlugin.h 
 

typedef struct sqSurfaceDispatch {
	/* Version information. Must be provided by the client
	   so the surface manager can check if certain operations
	   are supported. */
	int majorVersion;
	int minorVersion;

	/* Version 1.0 */
	fn_getSurfaceFormat getSurfaceFormat;
	fn_lockSurface lockSurface;
	fn_unlockSurface unlockSurface;
	fn_showSurface showSurface;
} sqSurfaceDispatch; 
!

!SQSurfaceDispatch classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/30/2011 12:30'!
fieldsDesc

"
A structure from SurfacePlugin.h 
 

typedef struct sqSurfaceDispatch {
	/* Version information. Must be provided by the client
	   so the surface manager can check if certain operations
	   are supported. */
	int majorVersion;
	int minorVersion;

	/* Version 1.0 */
	fn_getSurfaceFormat getSurfaceFormat;
	fn_lockSurface lockSurface;
	fn_unlockSurface unlockSurface;
	fn_showSurface showSurface;
} sqSurfaceDispatch; 
"
	^ #(
		int majorVersion;
		int minorVersion;
		void* getSurfaceFormatFn;
		void* lockSurfaceFn;
		void* unlockSurfaceFn;
		void* showSurfaceFn
	)! !

!SQSurfaceDispatch methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/30/2011 12:35'!
initialize
	self
		majorVersion: 1; 
		minorVersion: 0! !

AthensPaint subclass: #AthensCairoSolidPaint
	uses: TCairoLibrary
	instanceVariableNames: 'r g b a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Paints'!

AthensCairoSolidPaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoSolidPaint methodsFor: 'as yet unclassified' stamp: ''!
asAthensPaintOn: anAthensCairoCanvas 
	^ self ! !

!AthensCairoSolidPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:54'!
asStrokePaint
	^ AthensCairoStrokePaint new fillPaint: self! !

!AthensCairoSolidPaint methodsFor: 'accessing' stamp: 'IgorStasenko 3/28/2012 18:27'!
color: aColor
	r := aColor red.
	g := aColor green.
	b := aColor blue.
	a := aColor alpha.! !

!AthensCairoSolidPaint methodsFor: 'private' stamp: ''!
fillOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (AthensCairoCanvas aCanvas ))
! !

!AthensCairoSolidPaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/21/2012 19:03'!
fillPath: path on: anAthensCanvas 
	self loadOn: anAthensCanvas.
	anAthensCanvas
		newPath;
		loadPath: path.
		
	self fillOn: anAthensCanvas! !

!AthensCairoSolidPaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/28/2012 18:22'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	self loadOn: anAthensCanvas.
	anAthensCanvas 
		newPath;
		rectangleX: aRect left y: aRect top width: aRect width height: aRect height .
	self fillOn: anAthensCanvas! !

!AthensCairoSolidPaint methodsFor: 'private' stamp: 'IgorStasenko 3/28/2012 18:26'!
loadOn: anAthensCanvas
	anAthensCanvas
		setSourceR: r g: g b: b a: a
	! !

AthensPathBuilder subclass: #AthensCairoPathBuilder
	uses: TCairoLibrary
	instanceVariableNames: 'context absolute endPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Paths'!

AthensCairoPathBuilder class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoPathBuilder classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 14:53'!
buildPathFrom:  aPathCreatingBlock 

	! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:45'!
absolute
	absolute := true! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:36'!
angleOfVector: v

	| n acos |
	
	n := v normalized.
	acos := n x arcCos.
	
	^ v y < 0 ifTrue: [ Float pi * 2 - acos ] ifFalse: [ acos ]! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:47'!
arcCenterX: xc centerY: yc radius: radius startAngle: angle1 endAngle: angle2 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_arc (AthensCairoCanvas context,
				double xc,
				double yc,
				double radius,
				double angle1,
				double angle2) )
				
			! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:01'!
arcNegativeCenterX: xc centerY: yc radius: radius startAngle: angle1 endAngle: angle2 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_arc_negative (AthensCairoCanvas context,
				double xc,
				double yc,
				double radius,
				double angle1,
				double angle2) )
				
			! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:12'!
arcTo: newEndPoint angle: angle cw: aBool

	" Add a clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"

	| start end center v radius startAngle endAngle cwAngle |	
	start := endPoint.
	endPoint := end := self toAbsolute: newEndPoint.

	"we have to transform the input. because Cario expects 
	the center , radius, starting and ending angle,
	and we have the starting point, the ending point , and the angle.
	"
	aBool ifTrue: [cwAngle := angle] ifFalse: [cwAngle := angle negated].
	center := self calcCenter: start end: end  angle: cwAngle.
	v := (start - center).
	radius := v r.
	startAngle := self angleOfVector: v.
	endAngle := self angleOfVector: (end-center).
	aBool ifTrue: [ self arcCenterX: center x centerY: center y  radius: radius  startAngle: startAngle endAngle: endAngle ]
		ifFalse: [ self arcNegativeCenterX: center x centerY: center y  radius: radius  startAngle: startAngle  endAngle: endAngle ]
		! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:54'!
calcCenter: start end: end angle: angle

	| v  rot  center radius len sina cosa m |	

	v := end - start.
	
	m := AthensAffineTransform new rotateByRadians: (Float pi - angle   /2).

	v := m transform: v.		
	len := v r.
	radius := len / 2 / (angle /2) sin.
	
	center := v * (radius/len) + start.

	^ center! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/8/2012 17:06'!
ccwArcTo: newEndPoint angle: angle
	" Add a counter-clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"
	^ self arcTo: newEndPoint angle: angle cw: false! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'FernandoOlivero 3/9/2012 14:42'!
close

	self closePath.
	
	endPoint := self getCurrentPoint! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'FernandoOlivero 3/9/2012 14:43'!
closePath
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_close_path (AthensCairoCanvas context))! !

!AthensCairoPathBuilder methodsFor: 'accessing' stamp: 'IgorStasenko 3/7/2012 15:15'!
context: anObject

	context := anObject! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:47'!
copyPath 


	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( AthensCairoPath cairo_copy_path (AthensCairoCanvas context) )
! !

!AthensCairoPathBuilder methodsFor: 'accessing' stamp: 'IgorStasenko 3/7/2012 17:15'!
createPath: aBlock
	
	self newPath.
	"set default to relative"
	absolute := false.
	endPoint := ZeroPoint.
	
	"set the implicit path origin"
	self moveToX: 0 Y: 0.
		
	aBlock value: self.
	
	^ self copyPath initialize ! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'FernandoOlivero 3/11/2012 00:52'!
curveVia: p1 and: p2 to: aPoint
	|  pt1 pt2 |

	pt1 := self toAbsolute: p1.
	pt2 := self toAbsolute: p2.
	endPoint := self toAbsolute: aPoint.

	self curveViaX: pt1 x Y: pt1 y viaX: pt2 x Y: pt2 y toX: endPoint x Y: endPoint y
! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 17:45'!
curveVia: p1 to: aPoint
	| pt0 pt1 cp1 cp2 twoThirds |
	"Quad bezier curve"

	pt0 := endPoint.
	pt1 := self toAbsolute: p1.
	endPoint := self toAbsolute: aPoint.

"Any quadratic spline can be expressed as a cubic (where the cubic term is zero). The end points of the cubic will be the same as the quadratic's.

	CP0 = QP0
	CP3 = QP2

The two control points for the cubic are:

	CP1 = QP0 + 2/3 *(QP1-QP0)
	CP2 = QP2 + 2/3 *(QP1-QP2)"

	twoThirds := (2/3) asFloat.

	cp1 := pt1 - pt0 * twoThirds + pt0.
	cp2 := pt1 - endPoint * twoThirds + endPoint.
	
	self curveViaX: cp1 x Y: cp1 y viaX: cp2 x Y: cp2 y toX: endPoint x Y: endPoint y
! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 17:39'!
curveViaX: x1 Y: y1 viaX: x2 Y: y2 toX: x3 Y: y3
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_curve_to(AthensCairoCanvas context,
                                                         double x1,
                                                         double y1,
                                                         double x2,
                                                         double y2,
                                                         double x3,
                                                         double y3))

! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/8/2012 17:05'!
cwArcTo: newEndPoint angle: angle
	" Add a clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"
	^ self arcTo: newEndPoint angle: angle cw: true! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:43'!
getCurrentPoint
	| bx by |
	bx := ByteArray new: (NBExternalType sizeOf: 'double').
	by := bx copy.

	self getCurrentPoint: bx y: by.
	
	^ (bx nbDoubleAt: 1 ) @ (by nbDoubleAt: 1)! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:30'!
getCurrentPoint: bx y: by
	" move command always starts a new contour "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_move_to (AthensCairoCanvas context,
		 double * bx, double * by ) )
! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'FernandoOlivero 3/29/2012 18:18'!
lineTo: aPoint

	endPoint := self toAbsolute: aPoint.
	^ self lineToX: endPoint x asFloat Y: endPoint y asFloat! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:08'!
lineToX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_line_to (AthensCairoCanvas context,
		 double x, double y ) )
! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'FernandoOlivero 3/29/2012 14:16'!
moveTo: aPoint
	
	endPoint := self toAbsolute: aPoint.
	
	^ self moveToX: endPoint x asFloat Y: endPoint y asFloat ! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:07'!
moveToX: x Y: y
	" move command always starts a new contour "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_move_to (AthensCairoCanvas context,
		 double x, double y ) )
! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:04'!
newPath
 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void cairo_new_path ( AthensCairoCanvas context ) )! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:45'!
relative
	absolute := false! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:20'!
toAbsolute: aPoint

	^ absolute ifTrue: [ aPoint ] ifFalse: [ endPoint + aPoint ]! !

AthensTransform subclass: #AthensCairoTransform
	uses: TCairoLibrary
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Transforms'!

AthensCairoTransform class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoTransform classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:49'!
for: cairoCanvas
	^ self new canvas: cairoCanvas! !

!AthensCairoTransform methodsFor: 'initializing' stamp: 'IgorStasenko 12/20/2011 16:43'!
canvas: aCairoCanvas
	canvas := aCairoCanvas! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:47'!
loadIdentity

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_identity_matrix (AthensCairoCanvas canvas) )

! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/15/2012 19:39'!
moveTo: aPoint
	self moveToX: aPoint x asFloat Y: aPoint y asFloat! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 20:31'!
moveToX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_move_to (AthensCairoCanvas canvas,
                                                         double px,
                                                         double py))

! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/21/2011 13:43'!
primTransformX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_user_to_device (AthensCairoCanvas canvas,
                                                         NBFloatPtr x,
                                                         NBFloatPtr y) )
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 00:32'!
restore
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_restore(AthensCairoCanvas canvas))
! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/7/2012 13:55'!
restoreAfter: aBlock
	self save.
	aBlock ensure:  [ self restore ].! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:45'!
rotateByDegrees: angle

	^ self rotateByRadians: angle degreesToRadians! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:45'!
rotateByRadians: angle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_rotate (AthensCairoCanvas canvas,
                                                         double angle))

! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 00:32'!
save
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_save (AthensCairoCanvas canvas))
! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/15/2012 16:49'!
scaleBy: aScalarOrPoint
	| double |
	aScalarOrPoint isPoint
		ifTrue:[
			self
				scaleX: aScalarOrPoint x asFloat
				Y: aScalarOrPoint y asFloat ]
		ifFalse:[ 
			double := aScalarOrPoint asFloat.
			self scaleX: double Y: double ].
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:44'!
scaleX: fx Y: fy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_scale (AthensCairoCanvas canvas,
                                                         double fx,
                                                         double fy))

! !

!AthensCairoTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 12/21/2011 13:42'!
transform: aPoint
	| x y |
	"since we use pointers to floats we must create a copy of original values to not scratch them"
	x := aPoint x asFloat shallowCopy.
	y := aPoint y asFloat shallowCopy.
	
	self primTransformX: x Y: y.
	^ x @ y! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/14/2012 00:38'!
translateBy: aPoint
	self translateX: aPoint x Y: aPoint y
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:54'!
translateX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_translate (AthensCairoCanvas canvas,
                                                         double px,
                                                         double py))

! !

AthensCanvas subclass: #AthensCairoCanvas
	instanceVariableNames: 'handle pathTransform paintTransform'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

!AthensCairoCanvas commentStamp: 'IgorStasenko 12/20/2011 15:58' prior: 0!
my instances representing a low-level cairo context and mapped to cairo_t * C type!

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:45'!
asNBExternalType: gen
	"use handle ivar to hold my instance (cairo_t)"
	^ NBExternalObjectType objectClass: self! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:12'!
nbLibraryNameOrHandle
	^ AthensCairoSurface nbLibraryNameOrHandle! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:14'!
on: cairoSurface

	^ (self primCreate: cairoSurface) surface: cairoSurface! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:14'!
primCreate: cairoSurface

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( 
		AthensCairoCanvas cairo_create (AthensCairoSurface cairoSurface) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 12:20'!
clip
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_clip (self))
! !

!AthensCairoCanvas methodsFor: 'drawing' stamp: 'FernandoOlivero 1/17/2012 11:22'!
clipBy: aRectangle during: aBlock
	self
		rectangleX: aRectangle origin x
		y: aRectangle origin y
		width: aRectangle width
		height: aRectangle height;
		clip.
	aBlock ensure: [ self resetClip ]! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:56'!
destroy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( 	void cairo_destroy (self) )! !

!AthensCairoCanvas methodsFor: 'drawing' stamp: 'IgorStasenko 3/30/2012 18:05'!
draw
	"Fill the shape (anObject) using currently selected paint
	an object should implement double-dispatch to currently selected paint"
	
	"set the trasformation matrix"
	self setPathMatrix.

	^ shape paintFillsUsing: paint on: self

! !

!AthensCairoCanvas methodsFor: 'drawing' stamp: 'FernandoOlivero 3/30/2012 14:46'!
drawString: aString in: aRectangle font: aFont color: aColor 
	| text pt |
	text := AthensCairoText new.
	text
		
		fontFamily: aFont familyName ;
		fontSize: aFont pointSize ;
		text: aString.
	self setPaint: aColor .
	pt := self pathTransform.
	pt restoreAfter:[
		pt translateBy: aRectangle origin.
		text drawOn:  self].
	
	! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:10'!
fill
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (self))
! !

!AthensCairoCanvas methodsFor: 'paths' stamp: 'IgorStasenko 3/8/2012 17:32'!
loadPath: aPath

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	 
	^ self nbCall: #( void cairo_append_path (self , AthensCairoPath aPath))
! !

!AthensCairoCanvas methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:11'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoCanvas methodsFor: 'private' stamp: ''!
newPath
 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void cairo_new_path ( self ) )! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: ''!
paintTransform
	^ paintTransform
! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 16:48'!
pathTransform
	^ pathTransform! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 3/30/2012 17:59'!
primGetSource
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #( cairo_pattern_t cairo_get_source ( self ) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:05'!
rectangleX: x y: y width: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_rectangle (self,
		 double x, double y,
		 double aWidth, double aHeight) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 11:22'!
resetClip
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_reset_clip (self))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 13:27'!
setOperator: aCairoOperatorT
	"http://cairographics.org/operators/"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_operator (self, cairo_operator_t aCairoOperatorT) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: ''!
setPathMatrix
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_matrix (self,
			AthensCairoMatrix  pathTransform) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:17'!
setSourceR: red g: green b: blue a: alpha

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( 
		void cairo_set_source_rgba ( self ,
			double red,
			double green,
			double blue,
			double alpha) )! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: 'IgorStasenko 3/21/2012 18:29'!
surface: aCairoSurface
	
	"initialize for given surface"
	surface := aCairoSurface.
	
	pathTransform := AthensCairoMatrix new.
	paintTransform := AthensCairoMatrix new.! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 1/15/2012 14:58'!
visitCloseSegment: closeSegment
	self closePath! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 2/14/2012 08:16'!
visitCubicSegment: anAthensCubicSegment
	|  destination controlPoint controlPoint2 |
	destination := anAthensCubicSegment to.
	controlPoint := anAthensCubicSegment via1.
	controlPoint2 := anAthensCubicSegment via2.
	self
		curveToX: destination x Y: destination y
		viaX: controlPoint x Y: controlPoint y
		andX: controlPoint2 x Y: controlPoint2 y
		 		
! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'IgorStasenko 12/20/2011 18:49'!
visitLineSegment: line

	^ self lineToX: line endPoint x Y: line endPoint y! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'IgorStasenko 12/20/2011 18:46'!
visitMoveSegment: mov 
	^ self moveToX: mov endPoint x Y: mov endPoint y! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 2/14/2012 08:17'!
visitQuadSegment: anAthensCubicSegment
	| destination controlPoint |
	destination := anAthensCubicSegment to.
	controlPoint := anAthensCubicSegment via.
	self
		curveToX: destination x Y: destination y
		viaX: controlPoint x Y: controlPoint y
		 ! !

NBExternalStructure variableByteSubclass: #AthensCairoMatrix
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Transforms'!

!AthensCairoMatrix commentStamp: '<historical>' prior: 0!
I implement an AthensAffineTransform interface.!

AthensCairoMatrix class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoMatrix classSide methodsFor: 'as yet unclassified' stamp: ''!
fieldsDesc
	^ #(
   double sx; double shx;
   double shy; double sy;
   double x; double y;	
	)! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
clearTranslation
	"reset a translation from matrix, leaving only scale and rotation"
	
	self x: 0.
	self y: 0.! !

!AthensCairoMatrix methodsFor: 'initialize-release' stamp: ''!
initialize
	self loadIdentity.! !

!AthensCairoMatrix methodsFor: 'private' stamp: ''!
initx: x y: y sx: sx sy: sy shx: shx shy: shy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #(
		void cairo_matrix_init (self,
			double sx,
			double shx,
			double shy,
			double sy,
			double x,
			double y))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
inverseTransform: aPoint 

	^ self inverted transform: aPoint! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
invert

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( cairo_status_t cairo_matrix_invert ( self))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
inverted

	^ self copy invert! !

!AthensCairoMatrix methodsFor: 'testing' stamp: ''!
is: aSymbol
	^ aSymbol = #cairoMatrix or:[ super is: aSymbol ].! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
loadAffineTransform: m
	self initx: m x y: m y sx: m sx sy: m sy shx: m shx shy: m shy! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
loadIdentity
	"initialize with identity transform"
	
	self primLoadIdentity ! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 3/28/2012 16:32'!
multiplyBy: anAthensAffineTransform
	
	self primMultiplyBy: (
		self class new loadAffineTransform: anAthensAffineTransform)! !

!AthensCairoMatrix methodsFor: 'as yet unclassified' stamp: ''!
primLoadIdentity
	"initialize with identity transform"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>

	^ self nbCall: #( void cairo_matrix_init_identity (self ) )! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 3/28/2012 16:34'!
primMultiplyBy: m
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>

	^self nbCall: #(void   cairo_matrix_multiply
		(self,
		self ,
		AthensCairoMatrix m ) )

! !

!AthensCairoMatrix methodsFor: 'private' stamp: ''!
primTransformX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_matrix_transform_point ( self, double * x, double * y))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
restoreAfter: aBlock
	|previous|
	previous := self copy.
	aBlock ensure: [ self loadAffineTransform: previous ]! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
rotateByDegrees: angle


	^ self rotateByRadians: angle degreesToRadians! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
rotateByRadians: angle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #(
		void cairo_matrix_rotate ( self,
                                                         double angle))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'FernandoOlivero 3/22/2012 13:35'!
scaleBy: factor

	"if factor is number, do a uniform scale, 
	if not, then factor is assument to be an instance of Point containing non-uniform scale for each axis"
	factor isPoint 
		ifTrue: [ self scaleX: factor x asFloat Y: factor y asFloat ] 
		ifFalse: [ self scaleX: factor asFloat Y: factor asFloat ]
! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
scaleX: fx Y: fy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #(
		void cairo_matrix_scale ( self,
                                                         double fx,
                                                         double fy))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
setRotationInRadians: radians

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_matrix_init_rotate ( self, double  radians))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
setScaleX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_matrix_init_scale ( self, double  x, double  y))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
setTranslateX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_matrix_init_translate ( self, double  x, double  y))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
transform: aPoint
	| x y |
	"since we use pointers to floats we must create a copy of original values to not scratch them"
	x := aPoint x asFloat shallowCopy.
	y := aPoint y asFloat shallowCopy.
	
	self primTransformX: x Y: y.
	^ x @ y! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
translateBy: aPoint
	self translateX: aPoint x Y: aPoint y
! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
translateX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #(
		void cairo_matrix_translate ( self,
                                                         double px,
                                                         double py))

! !

AthensStrokePaint subclass: #AthensCairoStrokePaint
	uses: TCairoLibrary
	instanceVariableNames: 'dashes'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

AthensCairoStrokePaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoStrokePaint methodsFor: 'as yet unclassified' stamp: ''!
asAthensPaintOn: anAthensCairoCanvas 
	^ self! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: ''!
asStrokePaint 
	^ self ! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:28'!
beBevel
	self joinStyle: CAIRO_LINE_JOIN_BEVEL! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:45'!
beButt
	self capStyle: CAIRO_LINE_CAP_BUTT.! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 2/14/2012 12:02'!
beCapRound
	self capStyle: CAIRO_LINE_CAP_ROUND! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 3/25/2012 21:24'!
beJoinRound
	self joinStyle: CAIRO_LINE_JOIN_ROUND ! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:29'!
beMiter
	self joinStyle: CAIRO_LINE_JOIN_MITER! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:45'!
beSquare
	self capStyle: CAIRO_LINE_CAP_SQUARE! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 23:47'!
dashes
	^ dashes! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 23:44'!
dashes: anAlternateCollectionOfLenghts offset: anOffset
	dashes := {anAlternateCollectionOfLenghts. anOffset asFloat}.! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/28/2012 18:21'!
fillPath: aPath on: anAthensCanvas
	self loadOn: anAthensCanvas.
	anAthensCanvas newPath; loadPath: aPath.
	self strokeOn: anAthensCanvas.
	! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/28/2012 18:21'!
fillRectangle: aRect on: anAthensCanvas
	self loadOn: anAthensCanvas.
	anAthensCanvas 
		newPath;
		rectangleX: aRect left
		y: aRect top 
		width: aRect width
		height: aRect height.

	self strokeOn: anAthensCanvas.	
! !

!AthensCairoStrokePaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/8/2012 17:24'!
initialize
	super initialize.

	width := 1.
	capStyle := joinStyle := nil.
! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'FernandoOlivero 1/13/2012 20:01'!
loadOn: aCanvas
	self fillPaint loadOn: aCanvas.
	self width notNil ifTrue:[ self primSetLineWidthOn: aCanvas].
	self joinStyle notNil ifTrue:[ self primSetLineJoinOn: aCanvas].
	self capStyle notNil ifTrue:[ self primSetLineCapOn: aCanvas].
	self dashes notNil ifTrue:[ self setDashesOn: aCanvas lengths: self dashes first offset: self dashes second ].! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:51'!
primSetDashesOn: aCanvas lengths: dashesLengths count: dashesCount offset: anOffset
"	void                cairo_set_dash                      (cairo_t *cr,
                                                         double *dashes,
                                                         int num_dashes,
                                                         double offset);"
<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_dash (
				AthensCairoCanvas aCanvas,
				double* dashesLengths,
				int dashesCount,
				double anOffset) )
! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:20'!
primSetLineCapOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_line_cap (
			AthensCairoCanvas aCanvas,
			cairo_line_cap_t capStyle) )! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:21'!
primSetLineJoinOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_line_join (
			AthensCairoCanvas aCanvas,
			cairo_line_join_t joinStyle) )! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:19'!
primSetLineWidthOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_line_width (
				AthensCairoCanvas aCanvas,
				double width) )
! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:52'!
setDashesOn: aCanvas lengths: dashesLengths offset: anOffset
	| count size bytes |
	count := dashesLengths size.
	count = 1 ifTrue:[ 
		^ self
			primSetDashesOn: aCanvas
			lengths: dashesLengths first 
			count: 1
			offset: anOffset ].

	bytes := ByteArray new: count * 4.
	size := 1.
	dashesLengths do:[:each|
			bytes nbUlongAt: size put: each.
			size := size + 4 ].
	self
		primSetDashesOn: aCanvas
		lengths: bytes
		count: count
		offset: anOffset! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:24'!
strokeOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_stroke(AthensCairoCanvas aCanvas))
! !

AthensPaint subclass: #AthensCairoSurfacePaint
	uses: TCairoLibrary
	instanceVariableNames: 'surface'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

AthensCairoSurfacePaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoSurfacePaint classSide methodsFor: 'as yet unclassified' stamp: ''!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!AthensCairoSurfacePaint methodsFor: 'accessing' stamp: ''!
extent
	^ surface extent ! !

!AthensCairoSurfacePaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/30/2012 17:46'!
fillOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (AthensCairoCanvas aCanvas ))
! !

!AthensCairoSurfacePaint methodsFor: 'drawing' stamp: ''!
fillPath: path on: anAthensCanvas 
	self loadOn: anAthensCanvas.
	anAthensCanvas
		newPath;
		loadPath: path.
		
	self fillOn: anAthensCanvas! !

!AthensCairoSurfacePaint methodsFor: 'drawing' stamp: ''!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	self loadOn: anAthensCanvas.

	anAthensCanvas
		rectangleX: aRect left
		y: aRect top
		width: aRect width
		height: aRect height.
	self fillOn: anAthensCanvas.	
! !

!AthensCairoSurfacePaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/30/2012 18:14'!
loadOn: aCanvas
	| src |
	self primSetSourceSurfaceOn: aCanvas x: 0.0 y: 0.0.
	
	src := aCanvas primGetSource.
	src 
		setMatrix: aCanvas paintTransform; 
		setExtendRepeat
! !

!AthensCairoSurfacePaint methodsFor: 'private' stamp: 'FernandoOlivero 2/1/2012 18:50'!
primSetSourceSurfaceOn: aCanvas x: x y: y
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #( void cairo_set_source_surface (
		AthensCairoCanvas aCanvas,
		AthensCairoSurface  surface,
		double x,
		double y ) )
! !

!AthensCairoSurfacePaint methodsFor: 'accessing' stamp: ''!
surface
	^ surface! !

!AthensCairoSurfacePaint methodsFor: 'accessing' stamp: ''!
surface: aSurface
	surface := aSurface! !

AthensAbstractPaint subclass: #CairoPNGPaint
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

!CairoPNGPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/12/2012 12:47'!
fileNamed: aFileName
	| image|
	image := self new.
	image initializeOnFileNamed: aFileName.
	^ image! !

!CairoPNGPaint methodsFor: 'converting' stamp: 'FernandoOlivero 3/29/2012 12:25'!
asAthensPaintOn: anAthensCanvas
	| surface err |
	 surface := anAthensCanvas surface class createFromFile: fileName  ifFailed:[:status| status ].
	surface isNumber not ifTrue:[ ^ surface asAthensPaintOn: anAthensCanvas ].
	surface =  CAIRO_STATUS_READ_ERROR ifTrue:[ err := 'Cairo couldnt read the file named ', fileName ]. 
	surface = CAIRO_STATUS_FILE_NOT_FOUND ifTrue:[  err := 'Cairo cant find the file named ', fileName].
	self error: err. 
	
 ! !

!CairoPNGPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/12/2012 12:47'!
initializeOnFileNamed: aFileName
	fileName := aFileName.! !

AthensSurface subclass: #AthensCairoSurface
	instanceVariableNames: 'handle context builder id'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

AthensCairoSurface class
	instanceVariableNames: 'uniqueSession dispatch dispatchStruct'!

!AthensCairoSurface commentStamp: 'IgorStasenko 12/20/2011 15:54' prior: 0!
my instance are mapped to cairo_image_surface_t* C type !

AthensCairoSurface class
	instanceVariableNames: 'uniqueSession dispatch dispatchStruct'!

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 14:49'!
asNBExternalType: gen
	"use handle ivar to hold my instance (cairo_surface_t)"
	^ NBExternalObjectType objectClass: self! !

!AthensCairoSurface classSide methodsFor: 'session management' stamp: ''!
checkSession
	uniqueSession == NativeBoost uniqueSessionObject ifFalse: [
		self initializeForNewSession
	].! !

!AthensCairoSurface classSide methodsFor: 'instance creation' stamp: 'IgorStasenko 3/30/2012 17:43'!
createFromFile: aFileName ifFailed: aBlock
 	|surface cstring |
	cstring := aFileName , (Character value:0) asString.
	surface :=  self primCreateFromFile: cstring.
	surface isSuccess not
		ifTrue: [ 
			self destroySurfaceHandle: surface handle value.
			^ aBlock cull: surface status ]
		ifFalse: [ surface initialize ].
	^ surface .! !

!AthensCairoSurface classSide methodsFor: 'surface plugin callbacks' stamp: ''!
createGetSurfaceFormatFn

	"
		int getSurfaceFormat(int handle, int* width, int* height, int* depth, int* isMSB);

		Return general information about the OS drawing surface.
		Return true if successful, false otherwise.

		The returned values describe the basic properties such as
		width, height, depth and LSB vs. MSB pixels.
	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #( int (int handle, int* width, int* height, int* depth, int* isMSB) )
		emit: [:gen :proxy :asm | | callInfo fnPtr |

			" the handle is a handle to cairo image surface (cairo_surface_t *) "

			"*width = cairo_image_surface_get_width ( handle )"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_width') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment;
			
			mov: (gen arg: #width) to: asm EDX;
			mov: asm EAX to: asm EDX ptr.
		
			"*height = cairo_image_surface_get_height ( handle )"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_height') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment;

			mov: (gen arg: #height) to: asm EDX;
			
"work around the bitblt bug which tries to access past the buffer size designated by width*height*depth "			
			dec: asm EAX;
			mov: asm EAX to: asm EDX ptr.

			"*depth = 32"
			asm 
				mov: (gen arg: #depth) to: asm EAX;
				mov: 32 to: asm EAX ptr.
			
			" *isMSB = false "
			asm 
				mov: (gen arg: #isMSB) to: asm EAX;
				mov: 0 to: asm EAX ptr;

			"return true"
				mov: 1 to: asm EAX
						
		].
	fn install.
	^ fn address! !

!AthensCairoSurface classSide methodsFor: 'surface plugin callbacks' stamp: ''!
createLockSurfaceFn

	"
	int lockSurface(int handle, int *pitch, int x, int y, int w, int h);
		Lock the bits of the surface.
		Return a pointer to the actual surface bits, or NULL on failure.
		If successful, store the pitch of the surface (e.g., the bytes
		per scan line).

		For equal source/dest handles only one locking operation is performed.
		This is to prevent locking of overlapping areas which does not work with
		certain APIs (e.g., DirectDraw prevents locking of overlapping areas). 
		A special case for non-overlapping but equal source/dest handle would 
		be possible but we would have to transfer this information over to 
		unlockSurfaces somehow (currently, only one unlock operation is 
		performed for equal source and dest handles). Also, this would require
		a change in the notion of ioLockSurface() which is right now interpreted
		as a hint and not as a requirement to lock only the specific portion of
		the surface.

		The arguments in ioLockSurface() provide the implementation with
		an explicit hint what area is affected. It can be very useful to
		know the max. affected area beforehand if getting the bits requires expensive
		copy operations (e.g., like a roundtrip to the X server or a glReadPixel op).
		However, the returned pointer *MUST* point to the virtual origin of the surface
		and not to the beginning of the rectangle. The promise made by BitBlt
		is to never access data outside the given rectangle (aligned to 4byte boundaries!!)
		so it is okay to return a pointer to the virtual origin that is actually outside
		the valid memory area.

		The area provided in ioLockSurface() is already clipped (e.g., it will always
		be inside the source and dest boundingBox) but it is not aligned to word boundaries
		yet. It is up to the support code to compute accurate alignment if necessary.
	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #(int (int handle, int *pitch, int x, int y, int w, int h) )
		emit: [:gen :proxy :asm | | callInfo fnPtr |

			" the handle is a handle to cairo image surface (cairo_surface_t *) "

			"*pitch = cairo_image_surface_get_stride ( handle )"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_stride') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment;
			
			mov: (gen arg: #pitch) to: asm EDX;
			mov: asm EAX to: asm EDX ptr.
		
			" return cairo_image_surface_get_data ()"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_data') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment
		].
	
	fn install.
	^ fn address! !

!AthensCairoSurface classSide methodsFor: 'surface plugin callbacks' stamp: ''!
createShowSurfaceFn

	"
	int showSurface(int handle, int x, int y, int w, int h);
		Display the contents of the surface on the actual screen.

		If ioShowSurface() is called the surface in question represents
		a Squeak DisplayScreen.

	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #(int (int handle, int x, int y, int w, int h))
		emit: [:gen :proxy :asm | 
			"do nothing"
			asm mov: 1 to: asm EAX
		].
	
	fn install.
	^ fn address! !

!AthensCairoSurface classSide methodsFor: 'surface plugin callbacks' stamp: ''!
createUnlockSurfaceFn

	"
		int unlockSurface(int handle, int x, int y, int w, int h);
		Unlock the bits of a (possibly modified) surface after BitBlt completed.
		The return value is ignored.

		The arguments provided specify the dirty region of the surface. If the
		surface is unmodified all arguments are set to zero.

	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #(int (int handle, int x, int y, int w, int h) )
		emit: [:gen :proxy :asm | 
			"do nothing"
		].
	
	fn install.
	^ fn address! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
destroySurfaceHandle: handle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_surface_destroy ( ulong handle ) )

! !

!AthensCairoSurface classSide methodsFor: 'surface plugin callbacks' stamp: ''!
dispatchStruct
	self checkSession.
	^ dispatchStruct! !

!AthensCairoSurface classSide methodsFor: 'instance creation' stamp: 'IgorStasenko 3/7/2012 15:32'!
extent: anExtent
	^ self extent: anExtent format: CAIRO_FORMAT_ARGB32 ! !

!AthensCairoSurface classSide methodsFor: 'instance creation' stamp: 'IgorStasenko 3/7/2012 15:32'!
extent: anExtent format: aFormat
	^ ( self primImage: aFormat width: anExtent x height: anExtent y ) initialize
! !

!AthensCairoSurface classSide methodsFor: 'finalize resources' stamp: ''!
finalizeResourceData: handleAndId
	| handle id |
	handle := handleAndId first.
	id := handleAndId second.
	
	(self findSurface: id) = handle ifFalse: [ 
		self error: 'surface is not registered with surface plugin'.
		].
	
	self unregisterSurfaceWithId: id.
	self destroySurfaceHandle: handle.
! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
findSurface: surfaceId
	| buf |
	buf := ByteArray new: 4.  "sizeof(int)"
	
	
	(self ioFindSurface: surfaceId handle: buf) ifTrue: [
		^ buf nbUlongAt: 1
		].
	
	^ nil. ! !

!AthensCairoSurface classSide methodsFor: 'surface plugin callbacks' stamp: ''!
fnPtr: anFnName

	^ NativeBoost loadSymbol: anFnName fromModule: self nbLibraryNameOrHandle.

! !

!AthensCairoSurface classSide methodsFor: 'session management' stamp: ''!
initializeForNewSession
	| ptr |
	uniqueSession := NativeBoost uniqueSessionObject.
	
	"create a dispatch structure"
	dispatchStruct := dispatch := SQSurfaceDispatch new.
	
	dispatch 
		getSurfaceFormatFn: self createGetSurfaceFormatFn;
		lockSurfaceFn: self createLockSurfaceFn;
		unlockSurfaceFn: self createUnlockSurfaceFn;
		showSurfaceFn: self createShowSurfaceFn.
		
	"now we should place this structure to external memory"
	
	ptr := NativeBoost allocate: (SQSurfaceDispatch instanceSize).
	NativeBoost memCopy: dispatch to: ptr size: (SQSurfaceDispatch instanceSize).
	
	dispatch := ptr.! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
ioFindSurface: id dispatch: dispPtr handle: handlePtr
"	int ioFindSurface(int surfaceID, sqSurfaceDispatch *fn, int *surfaceHandle);
		Find the surface with the given ID, and, optionally,
		the given set of surface functions. The registered handle
		is returned in surfaceHandle. Return true if successful
		(e.g., the surface has been found), false otherwise.
"


	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #( bool ioFindSurface(int id, void * dispPtr, int *handlePtr) ) module: #SurfacePlugin! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
ioFindSurface: id handle: handlePtr
"	int ioFindSurface(int surfaceID, sqSurfaceDispatch *fn, int *surfaceHandle);
		Find the surface with the given ID, and, optionally,
		the given set of surface functions. The registered handle
		is returned in surfaceHandle. Return true if successful
		(e.g., the surface has been found), false otherwise.
"


	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #( bool ioFindSurface(int id, 0 , int *handlePtr) ) module: #SurfacePlugin! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
ioRegisterSurface: aCairoSurfaceHandle dispatch: sqSurfaceDispatchPtr surfaceId: idHolder
"
	int ioRegisterSurface(int surfaceHandle, sqSurfaceDispatch *fn, int *surfaceID);

	Register a new surface with the given handle and
	the set of surface functions. The new ID is returned
	in surfaceID. Returns true if successful, false 
	otherwise.

"

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #( bool ioRegisterSurface(ulong aCairoSurfaceHandle, void * sqSurfaceDispatchPtr, int *idHolder) ) module: #SurfacePlugin! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
ioUnregisterSurface: aCairoSurfaceId
"
	ioUnregisterSurface:
	Unregister the surface with the given id.
	Returns true if successful, false otherwise. 

"

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #( int ioUnregisterSurface(ulong aCairoSurfaceId) ) module: #SurfacePlugin! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:38'!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: 'FernandoOlivero 3/29/2012 12:04'!
primCreateFromFile: aFileName

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin> 
	
	^self nbCall: #(AthensCairoSurface cairo_image_surface_create_from_png (char* aFileName)) 
! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/12/2012 13:02'!
primImage: aFormat width: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(AthensCairoSurface cairo_image_surface_create (int aFormat,
                                                         int aWidth,
                                                         int aHeight) )

! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:01'!
primWidth: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( AthensCairoSurface cairo_image_surface_create (
						CAIRO_FORMAT_ARGB32,
						int aWidth,
						int aHeight) )! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: 'sig 3/30/2012 14:51'!
registerSurface: anAthensCairoSurface
	"register the cairo surface with surface plugin,
	so, it can be used directly by bitblt operations.
	
	Answer an id and unique session object
	 "
	| id |
	self checkSession.
	
	id := ByteArray new: (NBExternalType sizeOf: #int).

	(self ioRegisterSurface: anAthensCairoSurface handle value dispatch: dispatch surfaceId: id)
		ifFalse: [ self error: 'Unable to register surface with SurfacePlugin'].
	
	id := id nbLongAt: 1.
	
	^ id! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
testGetSurfaceFormat: handle width: wBuf height: hBuf depth: depthBuf isMSB: isMSBBuf

<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	NBFFICallout cdecl:  #( int (ulong handle, int* wBuf, int* hBuf, int* depthBuf, int* isMSBBuf) ) emitCall: [:gen :proxy :asm | 
		asm
			mov: (self dispatchStruct getSurfaceFormatFn) asUImm32 to: asm EAX;
			call: asm EAX
		]

! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
testLockSurface: handle pitch: pBuf x: x y: y w: w h: h

<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	NBFFICallout cdecl:  #( 	void *  (int handle, int *pBuf, int x, int y, int w, int h) ) emitCall: [:gen :proxy :asm | 
		asm
			mov: (self dispatchStruct lockSurfaceFn) asUImm32 to: asm EAX;
			call: asm EAX
		]

! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
testSurfacePluginCallbacks

	| surface wb hb db mb ptr |
	
	surface := AthensCairoSurface extent: 800@800.
	
	wb := ByteArray new: 4.
	hb := ByteArray new: 4.
	db := ByteArray new: 4.
	mb := ByteArray new: 4.
	
	self testGetSurfaceFormat: surface handle width: wb height: hb depth: db isMSB: mb.

	self assert: (surface width = (wb nbUlongAt: 1)).
	self assert: (surface height = (hb nbUlongAt: 1)).	
	self assert: (32 = (db nbUlongAt: 1)).
	self assert: (0 = (mb nbUlongAt: 1)).
	
	ptr := self testLockSurface: surface handle pitch:  wb x: 0  y: 0  w:  100 h: 100.
	self assert: (wb nbUlongAt: 1) = surface stride.
	self assert: ptr = surface getDataPtr! !

!AthensCairoSurface classSide methodsFor: 'private' stamp: ''!
unregisterSurfaceWithId: anAthensCairoSurfaceId

	self ioUnregisterSurface: anAthensCairoSurfaceId! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:02'!
width: aWidth height: aHeight
	^ (self primWidth: aWidth height: aHeight) initialize! !

!AthensCairoSurface methodsFor: 'converting' stamp: 'IgorStasenko 3/28/2012 17:27'!
asAthensPaintOn: aCanvas
	^ AthensCairoSurfacePaint new surface: self.
 ! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/23/2012 14:41'!
asForm

	"create a form and copy an image data there"
	
	^ Form extent: (self width@self height) depth: 32 bits: id! !

!AthensCairoSurface methodsFor: 'drawing' stamp: ''!
attemptToRecurseDrawing
	^ self ! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 3/30/2012 15:50'!
clear
        "#paint: with SOURCE_OVER operator"
        | pt |
        pt := currentCanvas pathTransform.
        
        pt restoreAfter: [
                pt loadIdentity.
                currentCanvas 
                        setPaint: (Color black alpha: 0);
                        setOperator:    CAIRO_OPERATOR_SOURCE;
                        drawShape: (0@0 extent: self extent);
                        setOperator:    CAIRO_OPERATOR_OVER
        ].! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/13/2012 22:31'!
createCircularGradient: colorRamp
	between: anInnerCenter
	radius: anInnerRadius
	and: anOuterCenter
	radius: anOuterRadius
 
	^AthensCairoPatternPaint	
		radialBetween: anInnerCenter
		extending: anInnerRadius
		and: anOuterCenter
		extending: anOuterRadius
		withColorRamp: colorRamp! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'IgorStasenko 3/21/2012 19:14'!
createCircularGradient: colorRamp center: aCenter radius: aRadius
	^ self 
		createCircularGradient: colorRamp
		between: aCenter
		radius: 0
		and: aCenter
		radius: aRadius
 ! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 3/9/2012 12:52'!
createFormPaint: aForm 
	^ FormPaint form: aForm.! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/25/2012 00:46'!
createImagePaint: aFileName 
	^ AthensCairoPngPaint fromFileNamed: aFileName asString.
	! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/13/2012 21:02'!
createLinearGradient: aColorRamp origin: aStart corner: aStop
	^ AthensCairoPatternPaint createLinearGradient: aColorRamp origin: aStart corner: aStop! !

!AthensCairoSurface methodsFor: 'creation' stamp: 'FernandoOlivero 3/26/2012 18:47'!
createPath: aPathCreatingBlock
	^ builder createPath:  aPathCreatingBlock ! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/13/2012 20:12'!
createSolidColorPaint: aColor 

	^ AthensCairoSolidPaint new color: aColor! !

!AthensCairoSurface methodsFor: 'drawing' stamp: 'IgorStasenko 3/7/2012 15:08'!
drawDuring: aBlock

	"You may draw on receiver only when inside a block and only using provided canvas object.
	This ensures releasing system resources used after finishing drawing"


	currentCanvas ifNotNil: [ self attemptToRecurseDrawing ].
	[
		currentCanvas := context.
		aBlock value: currentCanvas.
	] ensure: [
		currentCanvas := nil.
	].! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:18'!
extent
	^ self width @ self height! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:19'!
getDataPtr
	"get a pointer to surface bitmap data"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void* cairo_image_surface_get_data ( self ) )

! !

!AthensCairoSurface methodsFor: 'accessing' stamp: ''!
handle
	^ handle value! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:12'!
height
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_height ( self ) )

! !

!AthensCairoSurface methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/27/2012 18:34'!
initialize
	"the handle should be set already since we using an NB callout to create an instance"
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new surface' ].
	
	id := self class registerSurface: self.
		
	context := self newCanvas.
	builder := AthensCairoPathBuilder new.
	builder context: context.
	
	NBExternalResourceManager addResource: self.! !

!AthensCairoSurface methodsFor: 'testing' stamp: 'FernandoOlivero 1/12/2012 11:59'!
isSuccess
	^ self status  =	CAIRO_STATUS_SUCCESS! !

!AthensCairoSurface methodsFor: 'nb helper' stamp: 'IgorStasenko 12/16/2011 11:38'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:43'!
newCanvas
	"Answer a preinitialized instance of AthensCanvas.
	Private to receiver and its subclasses, override seldom"
	^ AthensCairoCanvas on: self
! !

!AthensCairoSurface methodsFor: 'initialize-release' stamp: ''!
resourceData
	^ { handle value. id }! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 3/30/2012 15:47'!
setOperator: op

        <primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
        
        ^ self nbCall: #( 
                void cairo_set_operator (self,  cairo_operator_t op) )! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 11:55'!
status

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(int cairo_surface_status (self) )
	! !

!AthensCairoSurface methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 12:00'!
statusToString: aCairoStatusT
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(String   cairo_status_to_string  (cairo_status_t aCairoStatusT))! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:10'!
stride
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_stride ( self ) )

! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:12'!
width
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_width ( self ) )

! !

!AthensCairoSurface methodsFor: 'converting' stamp: 'FernandoOlivero 1/12/2012 12:54'!
writeToPng: aFileName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_surface_write_to_png (self, String aFileName) )
! !

Object subclass: #AthensCairoText
	uses: TCairoLibrary
	instanceVariableNames: 'text fontFamily fontSlant fontWeight fontSize'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Text'!

AthensCairoText class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoText classSide methodsFor: 'as yet unclassified' stamp: ''!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:35'!
asString
	^ text asString! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
beBold
	self fontWeight: CAIRO_FONT_WEIGHT_BOLD! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 19:40'!
beNormal
	self fontWeight: CAIRO_FONT_WEIGHT_NORMAL! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
beSlantNormal
	self fontSlant: CAIRO_FONT_SLANT_NORMAL! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 4/7/2012 12:12'!
drawOn: aCanvas
	self loadOn: aCanvas.
	self showOn: aCanvas! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontFamily

	^ fontFamily! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 19:42'!
fontFamily: anObject
	"CSS2 generic family names: serif, sans-serif, cursive, fantasy, monospace"
	fontFamily := anObject! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontSize

	^ fontSize! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontSize: anObject

	fontSize := anObject! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:24'!
fontSlant

	^ fontSlant! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 20:00'!
fontSlant: anObject
	anObject isSymbol
		ifTrue:[ fontSlant := self slantFrom: anObject ]
		ifFalse:[ fontSlant := anObject ]! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:24'!
fontWeight

	^ fontWeight! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/25/2012 01:03'!
fontWeight: anObject
	anObject isSymbol
		ifTrue:[ fontWeight := self weightFrom: anObject ]
		ifFalse:[ fontWeight :=  anObject ] ! !

!AthensCairoText methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 3/30/2012 14:49'!
initialize
	super initialize.
	
	self beNormal; beSlantNormal.
	 fontSize := 10.! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 3/30/2012 14:49'!
loadOn: aCanvas
	fontFamily notNil ifTrue:[
		self
			primSelectFont:  fontFamily
				slant:  fontSlant
				weight:  fontWeight 
				on: aCanvas] .
	fontSize notNil ifTrue:[		
		self primSetFontSize:  fontSize on: aCanvas ]! !

!AthensCairoText methodsFor: 'as yet unclassified' stamp: ''!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:00'!
primSelectFont: aFontFamily
		slant: aFontSlant
		weight: aFontWeight 
		on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_select_font_face (
			cairo_t aCanvas,
   			char * aFontFamily,
      		cairo_font_slant_t aFontSlant,
        	cairo_font_weight_t aFontWeight) )
	! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/14/2012 18:31'!
primSetFontSize: aFontSize on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_set_font_size (
			cairo_t aCanvas,
			double aFontSize) )
! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 00:59'!
primShowText: aString on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_show_text (
			cairo_t aCanvas,
			char * aString) )
! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 20:10'!
readFrom: aFontDescription
	self fontFamily: aFontDescription fontFamily.
	self fontSlant: aFontDescription fontSlant.
	self fontWeight:  aFontDescription fontWeight.
	self fontSize: aFontDescription fontSize.! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 4/7/2012 12:12'!
showOn: aCanvas
	| cString|
	aCanvas setPathMatrix.
	cString := self asString copyWith: (Character value: 0).
	self primShowText: cString on: aCanvas! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:02'!
slantFrom: aSymbol
	^ aSymbol caseOf: {
		[#normal]->[ CAIRO_FONT_SLANT_NORMAL ].
 		[#italic]->[   CAIRO_FONT_SLANT_ITALIC ].
		[#oblique]->[ CAIRO_FONT_SLANT_OBLIQUE ] }! !

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:24'!
text

	^ text! !

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:24'!
text: anObject

	text := anObject! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:03'!
weightFrom: aSymbol
	^ aSymbol caseOf: {
		[#normal]->[ CAIRO_FONT_WEIGHT_NORMAL  ].
 		[#bold]->[    CAIRO_FONT_WEIGHT_BOLD ] }
! !

Object subclass: #AthensFontDescription
	instanceVariableNames: 'family options size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Text'!

!AthensFontDescription commentStamp: 'FernandoOlivero 1/24/2012 18:30' prior: 0!
Creates a new font description from a string representation in the form 
"[FAMILY-LIST] [STYLE-OPTIONS] [SIZE]", 

1)FAMILY-LIST is a comma separated list of families optionally terminated by a comma,

2)STYLE_OPTIONS is a whitespace separated list of words where each WORD describes one of style, variant, weight, stretch, or gravity. If STYLE-OPTIONS is missing, then all style options will be set to the default values

3)SIZE is a decimal number (size in points) or optionally followed by the unit modifier "px" for absolute size. 

!

!AthensFontDescription classSide methodsFor: 'examples' stamp: 'FernandoOlivero 1/24/2012 18:43'!
example
	| fDesc |
	fDesc := AthensFontDescription new. 
	fDesc
		family: 'monospace';
		fontSize: 22.
	^ fDesc! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 16:31'!
asString
	"[FAMILY-LIST] [STYLE-OPTIONS] [SIZE]"
	| str |
	str := '' writeStream.
	str nextPutAll:  family; space.
	"	
2)STYLE_OPTIONS is a whitespace separated list of words where each WORD describes one of style, variant, weight, stretch, or gravity. If STYLE-OPTIONS is missing, then all style options will be set to the default values
"
	#(slant. variant. weight. stretch. gravity) do:[:each|
		|val|
		val := options at: each ifAbsent: nil.
		val notNil ifTrue:[str nextPutAll: val ; space ]].
	
	self fontSize notNil ifTrue:[
		str
			space;
			nextPutAll: self fontSize asString ].
	^ str contents! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:07'!
beBold
	self weight: #bold! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:06'!
beItalic
	self slant: #italic! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:07'!
beNormal
	self slant: #normal ; weight: #normal.! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:06'!
beOblique
	self slant: #oblique! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:42'!
family: aFamilyName
	"CSS2 generic family names: serif, sans-serif, cursive, fantasy, monospace"
	family := aFamilyName.
	! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:10'!
fontFamily
	^ family! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:26'!
fontGravity
	^ options at: #gravity! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:09'!
fontSize
	^ size ! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/10/2012 12:12'!
fontSize: aPointSize
	size := aPointSize! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/25/2012 01:02'!
fontSlant
	^ options at: #slant ! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:26'!
fontStretch
	^ options at: #stretch! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:25'!
fontVariant
	^ options at: #variant ! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:06'!
fontWeight
	^ options at: #weight ! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
gravity: aNumber
	options at: #gravity put: aNumber.		
! !

!AthensFontDescription methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/14/2012 20:08'!
initialize
	super initialize.
	family := 'monospace'.
	options := Dictionary new.
	options
		at:#weight put: #normal; 
		at:#slant put: #normal.
	size := 14.
	! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:52'!
slant: aNumber
	options at: #slant put: aNumber.		
! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
stretch: aNumber
	options at: #stretch put: aNumber.		
! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
variant: aNumber
	options at: #variant put: aNumber.		
! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:52'!
weight: aNumber
	options at: #weight put: aNumber.		
! !

NBExternalObject subclass: #AthensCairoPath
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Paths'!

AthensCairoPath class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoPath classSide methodsFor: 'instance creation' stamp: ''!
finalizeResourceData: aHandle

	self primDestroyPath: aHandle value ! !

!AthensCairoPath classSide methodsFor: 'instance creation' stamp: ''!
primDestroyPath: aHandle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_path_destroy ( ulong aHandle ))
! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 3/28/2012 19:10'!
initialize 
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new path' ].

	NBExternalResourceManager addResource: self data: handle! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/8/2012 17:29'!
loadInto: context

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	 
	^ self nbCall: #( void cairo_append_path (AthensCairoCanvas context, self ))
! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:33'!
paintFillsUsing: aPaint on: anAthensCanvas 
	
	"This method is a part of rendering dispatch  Canvas->receiver->paint"
	
	^ aPaint fillPath: self on: anAthensCanvas! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 3/28/2012 19:12'!
primDestroyPath: aHandle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_path_destroy ( ulong aHandle ))
! !

NBExternalObject subclass: #AthensCairoPatternPaint
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

AthensCairoPatternPaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/21/2012 18:45'!
createLinearGradient: aColorRamp origin: aStart corner: aStop
	| paint |
	paint := self
		primCreateLinearXo: aStart x asFloat
		yo: aStart y asFloat
		x1: aStop x asFloat
		y1: aStop y asFloat.
	paint initialize.
	paint initializeLinearFrom: aStart to: aStop withColorRamp: aColorRamp.
	^ paint! !

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: ''!
finalizeResourceData: handle

	self primDestroyPattern: handle value ! !

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/13/2012 21:46'!
primCreateLinearXo: xo yo: yo x1: x1 y1: y1
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(cairo_pattern_t cairo_pattern_create_linear (
		double xo,
		double yo,
		double x1,
		double y1 ) )
! !

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 2/24/2012 19:38'!
primCreateRadialXo: xo yo: yo radiuso: radiuso x1: x1 y1: y1 radius1: radius1
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(cairo_pattern_t cairo_pattern_create_radial (
		double xo,
		double yo,
		double radiuso,
		double x1,
		double y1,
		double radius1 ) )
! !

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: ''!
primDestroyPattern: aHandle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_pattern_destroy (ulong aHandle) )
 ! !

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/13/2012 22:31'!
radialBetween: origin
	extending: innerRadius
	and: outerOrigin
	extending: outerRadius
	withColorRamp: colorRamp
	| paint |

	paint := self
		primCreateRadialXo: origin x 
		yo: origin y 
		radiuso: innerRadius 
		x1: outerOrigin x
		y1: outerOrigin y 
		radius1: outerRadius.
	paint
		initializeRadialBetween: origin
			extending: innerRadius
			and: outerOrigin
			extending: outerRadius
			withColorRamp: colorRamp.
	^ paint.! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/30/2012 17:12'!
addColorStopAt: anOffset colored: aColor
	| r g b a |
	a := 1.
	aColor isColor
		ifTrue:[
			r := aColor red.
			g := aColor green.
			b := aColor blue.
			a := aColor alpha]
		ifFalse:[
			r := aColor first.
			g := aColor second.
			b := aColor third.
			aColor size > 3 ifTrue:[ a := aColor fourth ]].
	self
		primAddColorStopOffset: anOffset R: r G: g B: b A: a! !

!AthensCairoPatternPaint methodsFor: 'converting' stamp: ''!
asAthensPaintOn: anAthensCanvas	
	^ self! !

!AthensCairoPatternPaint methodsFor: 'converting' stamp: 'FernandoOlivero 1/15/2012 02:59'!
asStrokePaint
	^ AthensCairoStrokePaint new fillPaint: self! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: ''!
fillOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (AthensCairoCanvas aCanvas ))
! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: ''!
fillPath: path on: anAthensCanvas 
	self loadOn: anAthensCanvas.
	anAthensCanvas
		newPath;
		loadPath: path.
		
	self fillOn: anAthensCanvas! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: ''!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	self loadOn: anAthensCanvas.

	anAthensCanvas
		rectangleX: aRect left
		y: aRect top
		width: aRect width
		height: aRect height.
	self fillOn: anAthensCanvas.	
! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: ''!
initialize
	
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new paint' ].
	
	"register to be finalized"
	NBExternalResourceManager addResource: self data: handle.! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/8/2012 17:37'!
initializeLinearFrom: aStart to: aStop withColorRamp: aRamp
	aRamp do:[:each|
		self
			addColorStopAt: each key
			colored: each value ]
	! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/8/2012 17:37'!
initializeRadialBetween: origin
			extending: innerRadius
			and: outerOrigin
			extending: outerRadius
			withColorRamp: aRamp
	aRamp do:[:each|
		self
			addColorStopAt: each key
			colored: each value ]
	! !

!AthensCairoPatternPaint methodsFor: 'testing' stamp: 'IgorStasenko 3/28/2012 18:50'!
isPatternTypeMismatch
	^ self status = CAIRO_STATUS_PATTERN_TYPE_MISMATCH.! !

!AthensCairoPatternPaint methodsFor: 'testing' stamp: ''!
isSuccess
	^ self status  =	CAIRO_STATUS_SUCCESS! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: 'FernandoOlivero 3/10/2012 19:19'!
loadOn: anAthensCanvas 
	self isSuccess
		ifTrue:[ self primSetSourceOn: anAthensCanvas.]
		ifFalse:[ anAthensCanvas setSourceR: 1.0 g: 0.0 b: 0.0 a: 1.0].
! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 20:15'!
primAddColorStopOffset: offset R: red G: green B: blue 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall:#(void cairo_pattern_add_color_stop_rgb    (cairo_pattern_t  self,
                                                         double offset,
                                                         double red,
                                                         double green,
                                                         double blue))
		! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 20:15'!
primAddColorStopOffset: offset R: red G: green B: blue A: alpha 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall:#(void cairo_pattern_add_color_stop_rgba    (cairo_pattern_t  self,
                                                         double offset,
                                                         double red,
                                                         double green,
                                                         double blue,
												double alpha ))
		! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'IgorStasenko 3/30/2012 18:13'!
primSetExtend: extend

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall:#(
		void cairo_pattern_set_extend ( self , ulong extend) )
		! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 21:52'!
primSetSourceOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_source ( cairo_t  aCanvas, cairo_pattern_t  self))
		! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'IgorStasenko 3/30/2012 18:13'!
setExtendRepeat
	self primSetExtend: 1! !

!AthensCairoPatternPaint methodsFor: 'accessing' stamp: 'IgorStasenko 3/30/2012 18:01'!
setMatrix: m

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #( 
		void
			cairo_pattern_set_matrix ( self, AthensCairoMatrix m)

		)
! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 20:15'!
status
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(int cairo_pattern_status (cairo_pattern_t  self))
		! !
